package com.chinacreator.video.service;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.restful.dao.JiYueReverseDao;
import com.chinacreator.video.restful.util.AesUtilByIntensive;
import com.chinacreator.video.util.SpringUtils;
import com.chinacreator.video.validate.IpValidate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

@Service
public class NengkaiService {

    private static final Logger log = LoggerFactory.getLogger("nengkai");

    @Autowired
    JiYueReverseDao jiYueReverseDao;

    @Autowired
    CancelForNengkaiService cancelForNengkaiService;

    @Autowired
    IpValidate ipValidate;

    @Autowired
    QueryOrderForNengkaiService queryOrderForNengkaiService;

    @Autowired
    AddBlockListForNengkaiService addBlockListForNengkaiService;

    @Autowired
    DeleteBlockListForNengkaiService deleteBlockListForNengkaiService;

    @Autowired
    QureyEquityService qureyEquityService;


    public JSONObject busiVali(String inputParams) throws Exception{
        JSONObject json =null;
        try {
            String data = JSON.parseObject(inputParams).getString("data");
            String cpid = JSON.parseObject(inputParams).getString("cpid");
            ipVali(cpid);//ip验证
            data = decrypt(data,cpid);
            json = JSON.parseObject(data);
            json.put("cpidChannel",cpid);
        }catch (Exception e) {
            if (e instanceof BussinessException){
                throw e;
            }else {
                e.printStackTrace();
                log.error("参数不合法，解析异常，"+e);
                throw new BussinessException("80015", "参数不合法，解析异常");
            }

        }
        return json;
    }

    public String operBusi(JSONObject object) throws Exception{
        String data = "";
        try {
            String busiid = object.getString("busiid");
            switch (busiid){
                case "cancelForNengkai":
                    data = cancelForNengkaiService.cancel(object);
                    break;
                case "queryOrderForNengkai":
                    data = queryOrderForNengkaiService.query(object);
                    break;
                case "addBlockListForNengkai":
                    data = addBlockListForNengkaiService.addBlock(object);
                    break;
                case "deleteBlockListForNengkai":
                    data = deleteBlockListForNengkaiService.deleteBlock(object);
                    break;
                case "receiveEquity":
                    qureyEquityService.receive(object);
                    break;
                default:
                    throw new BussinessException("8000", "业务异常");
            }
        }catch (Exception e){
            if(e instanceof BussinessException) {
                throw e;
            }else {
                e.printStackTrace();
                throw new BussinessException("8000", "系统异常请稍后再试");
            }
        }
        return data;
    }

    public String decrypt(String data,String cpid)throws  Exception{
        try {
            Map invoke = jiYueReverseDao.getInvokeUrl("univideo", cpid);
            JSONObject object = JSON.parseObject(invoke.get("PARAM1").toString());
            String aespwd = object.getString("aespwd");
            data = AesUtilByIntensive.decrypt(data, aespwd);
        }finally {
            log.info("解密后data"+data);
        }
        return data;
    }

    public String encrypt(String data,String cpid)throws  Exception{
        try {
            Map invoke = jiYueReverseDao.getInvokeUrl("univideo", cpid);
            JSONObject object = JSON.parseObject(invoke.get("PARAM1").toString());
            String aespwd = object.getString("aespwd");
            data = AesUtilByIntensive.encrypt(data, aespwd);
        }finally {
            log.info("加密后data"+data);
        }
        return data;
    }

    public void ipVali(String cpid) throws Exception {
        OrderInfo orderInfo = new OrderInfo();
        orderInfo.setChannel(cpid);
        orderInfo.setCpid(cpid);
        orderInfo.setSpid(cpid);
        orderInfo.setInvokeface(cpid);
        ipValidate.volidate(orderInfo);
    }
}
