package com.chinacreator.video.service;

import com.alibaba.druid.util.StringUtils;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.CommConfDao;
import com.chinacreator.video.mapper.CpSpDao;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.mapper.NengkaiDao;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@Service
public class QueryOrderForNengkaiService {

    private static final Logger log = LoggerFactory.getLogger("queryOrderForNengkai");

    @Autowired
    DictionaryDao dictionaryDao;

    @Autowired
    CpSpDao cpSpDao;

    @Autowired
    CommConfDao commConfDao;

    @Autowired
    NengkaiService nengkaiService;

    @Autowired
    NengkaiDao nengkaiDao;

    @Autowired
    QureyEquityService qureyEquityService;

    public String query(JSONObject object) throws Exception{
        String data = "";
        HashMap<String,String> logmap = new HashMap<>();
        logmap.put("入参",JSON.toJSONString(object));
        List dataList = new ArrayList();
        HashMap<String,Object> dataMap = new HashMap<>();
        try {
            check(object);
            List<HashMap> orderRelationsList = nengkaiDao.queryOrderRelations(object.getString("usermob"), object.getString("productname"), object.getString("prmproductid"));
            if (orderRelationsList!=null&&orderRelationsList.size()>0){
                for (HashMap map:orderRelationsList) {
                    HashMap<String,Object> ordermsg = new HashMap<>();
                    ordermsg.put("productname",map.get("SPNAME"));
                    ordermsg.put("productid",map.get("SPID"));
                    ordermsg.put("cbssproductid","");
                    ordermsg.put("packageid","");
                    ordermsg.put("discntid","");
                    ordermsg.put("prmproductid",map.get("VACPRODUCTID"));
                    ordermsg.put("channel","");
                    Object channel = map.get("CHANNEL");
                    String channelnum = "6";
                    if (channel!=null&&channel!=""){
                        String channelstr = nengkaiDao.queryChanel(channel.toString());
                        if (!StringUtils.isEmpty(channelstr)){
                            if (channelstr.contains("互联网")){
                                channelnum = "1";
                            }else if (channelstr.contains("省分线上")){
                                channelnum = "2";
                            }else if (channelstr.contains("省分线下")){
                                channelnum = "3";
                            }else if (channelstr.contains("集团渠道")){
                                channelnum = "4";
                            }else if (channelstr.contains("自有渠道")){
                                channelnum = "5";
                            }
                        }
                    }
                    ordermsg.put("channel",channelnum);
                    ordermsg.put("ordertime",map.get("ORDERTIME"));
                    ordermsg.put("canceltime",map.get("CANCELTIME"));
                    ordermsg.put("starttime",map.get("STARTTIME"));
                    ordermsg.put("endtime",map.get("ENDTIME"));
                    ordermsg.put("orderstatus",map.get("STATUS"));
                    ordermsg.put("ifcancel","0".equals(map.get("STATUS"))?"1":"0");
                    ordermsg.put("equityoffer","");
                    ordermsg.put("province",map.get("PROVINCE"));
                    ordermsg.put("city",map.get("AREA"));
                    ordermsg.put("postage",map.get("PRICE"));
                    ordermsg.put("chargetype","01");
                    ordermsg.put("transaction",new ArrayList<>());
                    List equitymsg = qureyEquityService.getVipInfo(object.getString("usermob"),map.get("SPID").toString(),map.get("CPID").toString(),("".equals(map.get("CHANNEL"))||map.get("CHANNEL")==null)?"":map.get("CHANNEL").toString(),("".equals(map.get("ORDERCHANNEL2"))||map.get("ORDERCHANNEL2")==null)?"":map.get("ORDERCHANNEL2").toString()); //获取权益信息
                    ordermsg.put("equitymsg",equitymsg);
                    dataList.add(ordermsg);

                }
            }
            dataMap.put("ordermsg",dataList);
            HashMap hashMap = queryBlack(object.getString("usermob")); //获取黑名单
            dataMap.put("blacklist",hashMap);

            logmap.put("data",JSON.toJSONString(dataMap));
            if (dataMap!=null&&dataMap.size()>0){
                data = nengkaiService.encrypt(JSON.toJSONString(dataMap),object.getString("cpidChannel"));
            }else {
                data = "";
            }
        }catch (Exception e){
            if(e instanceof BussinessException) {
                throw e;
            }else {
                e.printStackTrace();
                throw new BussinessException("8000","查询出现异常");
            }
        }finally {
            log.info(JSON.toJSONString(logmap));
        }
        return data;
    }

    private void check(JSONObject object)throws Exception{
        if (StringUtils.isEmpty(object.getString("usermob"))){
            throw new BussinessException("80003", "参数缺失");
        }
    }

    private HashMap queryBlack(String userid){
        List<HashMap> hashMaps = nengkaiDao.queryBlack(userid);
        HashMap<String,Object> map = new HashMap<>();
        if (hashMaps!=null&&hashMaps.size()>0){
            map.put("blackstatus","0");
            map.put("blacktime",hashMaps.get(0).get("BLACKTIME"));
            map.put("blackcause",hashMaps.get(0).get("BLACKCAUSE"));
            map.put("isdel","1");
        }else {
            map.put("blackstatus","1");
            map.put("blacktime","");
            map.put("blackcause","");
            map.put("isdel","0");
        }
        return map;
    }
}
