package com.chinacreator.video.web;

import cn.hutool.http.HttpRequest;
import cn.hutool.json.JSONUtil;
import com.chinacreator.video.annotation.Log;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.dto.DataOutPipe;
import com.chinacreator.video.dto.IncrDataOutPipe;
import com.chinacreator.video.service.HandleService;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;


@RestController
@Slf4j
public class HanddleControl {

    /**
     * 订购改造 暂定延迟上线
     */
    /*	private static Logger logger = Logger.getLogger("handdleControl");*/
    private static final Logger logger = LoggerFactory.getLogger(HanddleControl.class);
    private final static String FLOW_HANDLE_URL = "https://opapi.bol.wo.cn/changshi/test/flow/flowHandle";
    @Autowired
    private HandleService handleService;

    @Log
    @RequestMapping("/handle")
    public DataOutPipe<?> handle(OrderInfo orderInfo) throws Exception {
        IncrDataOutPipe outpipe = new IncrDataOutPipe();
        orderInfo.setInvokeface("handle");
        String spid = orderInfo.getSpid();
        HashMap spInfo = handleService.findSpInfo(spid);
        log.info("订购接口参数:{}", JSONUtil.toJsonStr(spInfo));
        if ("6".equalsIgnoreCase( spInfo.get("PAYTYPE")+"")) {
            //转发出去
            String json = JSONUtil.toJsonStr(orderInfo);
			log.info("订购接口转发参数:{}", JSONUtil.toJsonStr(json));

			String result2 = HttpRequest.post(FLOW_HANDLE_URL)
                    .body(json)
                    .execute().body();
			log.info("订购接口转发结果:{}", result2);
        }

        handleService.check(orderInfo);
        handleService.handle(orderInfo);
		/*if ("0".equals(orderInfo.getType())) {

				HashMap<Object, Object> logMap = new HashMap<>();

			try {
				handleService.check(orderInfo);
				handleService.handle(orderInfo);
			} catch (Exception e) {
				e.printStackTrace();
				String errorinfo2 = "系统处理失败";
				String errorcode2 = "80000";
				if(e instanceof BussinessException) {
					String errorcode = ((BussinessException) e).getCode();
					String errorinfo = e.getMessage();
					logMap.put("errorcode", errorcode);
					logMap.put("errorinfo", errorinfo);
					if ("80001".equals(errorcode)) {
						String errorcode1 = "80001";
						String errorinfo1 = "用户欠费";
						throw new BussinessException(errorcode1, errorinfo1);
					} else if ("80002".equals(errorcode)){
						String errorcode1 = "80002";
						String errorinfo1 = "非联通用户订购";
						throw new BussinessException(errorcode1, errorinfo1);
					}else {
						throw new BussinessException(errorcode2, errorinfo2);
					}
				}else {
					logMap.put("errorinfo",e.getMessage());
					throw new BussinessException(errorcode2, errorinfo2);
				}
			}finally {
				logMap.put("orderInfo", JSON.toJSONString(orderInfo));
				logger.info(logMap);
			}
		}else {
			handleService.check(orderInfo);
			handleService.handle(orderInfo);
		}*/

        return outpipe;
    }
}
