package com.chinacreator.video.web;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.NengkaiDao;
import com.chinacreator.video.restful.bean.JiyueOrderBean;
import com.chinacreator.video.restful.bean.OrderInfo;
import com.chinacreator.video.service.NengkaiService;
import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
public class NengkaiControl {

    private static final Logger log = LoggerFactory.getLogger("nengkai");

    @Autowired
    NengkaiService service;

    @RequestMapping(value = "/nengkai", method = RequestMethod.POST, produces = "application/json")
    public String nengkai(@RequestBody String params, HttpServletRequest request)throws Exception{
        Map<String,Object> logmap = new HashMap<String,Object>();
        String inputParams = "";
        HashMap<String,String> outputParams = new HashMap<String,String>();
        String resultCode = "0000";
        String resultInfo = "ok";
        String data ="";
        try {
            inputParams = params; //JSON.toJSONString(params); //输入参数
            logmap.put("inputParams",inputParams);
            JSONObject object = service.busiVali(inputParams);
            data = service.operBusi(object);
        }catch (Exception e){
            e.printStackTrace();
            if(e instanceof BussinessException) {
                resultCode = ((BussinessException) e).getCode();
                resultInfo = ((BussinessException) e).getMessage();
            }else {
                resultCode = "8003";
                resultInfo = "出现异常，"+e.getMessage();
            }
        }finally {
            logmap.put("resultCode",resultCode);
            logmap.put("errorInfo",resultInfo);
            logmap.put("data",data);
            outputParams.put("resultCode",resultCode);
            outputParams.put("resultInfo",resultInfo);
            outputParams.put("data",data);
            log.info(JSON.toJSONString(logmap));
            return JSON.toJSONString(outputParams);
        }

    }

}
